;*******************************************************************************
;*                                                                             *
;*          Hidden BASIC for TRS-80 Color Computer                             *
;*          April 1, 1983                                                      *
;*                                                                             *
;*          David Rowland                                                      *
;*          Color-Phaze Inc.                                                   *
;*          PO Box 7954                                                        *
;*          Greenville, SC 29640                                               *
;*                                                                             *
;*          Disassembly by Paul Fiscarelli                                     *
;*          November 25, 2024                                                  *
;*                                                                             *
;*******************************************************************************

;*****************************************************
;** Used Labels                                      *
;*****************************************************

m0000           equ     $0000
m0003           equ     $0003
m000a           equ     $000a
m0019           equ     $0019
m001b           equ     $001b
m007c           equ     $007c
m007d           equ     $007d
m007e           equ     $007e
m008e           equ     $008e
m009f           equ     $009f
m00ff           equ     $00ff
m0121           equ     $0121
m0126           equ     $0126
m012b           equ     $012b
m0130           equ     $0130
m01d2           equ     $01d2
m01da           equ     $01da
m01e2           equ     $01e2
m01e3           equ     $01e3
m01e4           equ     $01e4
m01e5           equ     $01e5
m01e6           equ     $01e6
m01e7           equ     $01e7
m01e8           equ     $01e8
m0400           equ     $0400
m044a           equ     $044a
m044d           equ     $044d
m0544           equ     $0544
m0546           equ     $0546
m0548           equ     $0548
m0549           equ     $0549
m0600           equ     $0600
m0601           equ     $0601
m2d60           equ     $2d60
m2d62           equ     $2d62
z307a           equ     $307a
z31ef           equ     $31ef
m32ab           equ     $32ab
m3239           equ     $3239
m33bd           equ     $33bd
m3530           equ     $3530
m3533           equ     $3533
m353b           equ     $353b
m361b           equ     $361b
m3666           equ     $3666
m36af           equ     $36af
m36bb           equ     $36bb
m36c0           equ     $36c0
m36ce           equ     $36ce
m36ed           equ     $36ed
m3719           equ     $3719
m4558           equ     $4558
m4d45           equ     $4d45
m4e41           equ     $4e41
m8000           equ     $8000
m8183           equ     $8183
m8264           equ     $8264
ma11d           equ     $a11d
ma129           equ     $a129
ma15a           equ     $a15a
ma15f           equ     $a15f
maa66           equ     $aa66
mab88           equ     $ab88
mfde8           equ     $fde8

za000           equ     $a000
za06e           equ     $a06e
za471           equ     $a471
za4d0           equ     $a4d0
za529           equ     $a529
za663           equ     $a663
za7ca           equ     $a7ca
za7e9           equ     $a7e9
za928           equ     $a928
za976           equ     $a976
za9a2           equ     $a9a2

;*****************************************************
;** Program Code / Data Areas                        *
;*****************************************************

                org     $3080
Start
                jsr     za9a2                    *3080: bd a9 a2       '...'
                jsr     za976                    *3083: bd a9 76       '..v'
                ldx     #m0400                   *3086: 8e 04 00       '...'
                lda     #$60                     *3089: 86 60          '.`'
z308b           sta     ,x+                      *308b: a7 80          '..'
                cmpx    #m0601                   *308d: 8c 06 01       '...'
                bne     z308b                    *3090: 26 f9          '&.'
                bra     z30bc                    *3092: 20 28          ' ('

m3094           fcc     "HIDDEN BASIC"
m30a0           fcc     "(C) 1983 BY COLOR-PHAZE INC."

z30bc           jsr     z30c2                    *30bc: bd 30 c2       '.0.'
                lbra    z30f1                    *30bf: 16 00 2f       '../'
z30c2           ldx     #m044a                   *30c2: 8e 04 4a       '..J'
                ldy     #m3094                   *30c5: 10 8e 30 94    '..0.'
z30c9           lda     ,y+                      *30c9: a6 a0          '..'
                cmpa    #$40                     *30cb: 81 40          '.@'
                lbls    z30e8                    *30cd: 10 23 00 17    '.#..'
z30d1           sta     ,x                       *30d1: a7 84          '..'
                leax    1,x                      *30d3: 30 01          '0.'
                cmpy    #m30a0                   *30d5: 10 8c 30 a0    '..0.'
                beq     z30e1                    *30d9: 27 06          ''.'
                cmpa    #$6e                     *30db: 81 6e          '.n'
                beq     z30e7                    *30dd: 27 08          ''.'
                bra     z30c9                    *30df: 20 e8          ' .'
z30e1           ldb     #$4c                     *30e1: c6 4c          '.L'
                abx                              *30e3: 3a             ':'
                lbra    z30c9                    *30e4: 16 ff e2       '...'
z30e7           rts                              *30e7: 39             '9'
z30e8           adda    ma15a                    *30e8: bb a1 5a       '..Z'
                adda    ma15f                    *30eb: bb a1 5f       '.._'
                lbra    z30d1                    *30ee: 16 ff e0       '...'
z30f1           nop                              *30f1: 12             '.'
                ldx     #m000a                   *30f2: 8e 00 0a       '...'
z30f5           ldy     #mfde8                   *30f5: 10 8e fd e8    '....'
z30f9           leay    -1,y                     *30f9: 31 3f          '1?'
                bne     z30f9                    *30fb: 26 fc          '&.'
                leax    -1,x                     *30fd: 30 1f          '0.'
                bne     z30f5                    *30ff: 26 f4          '&.'
                ldx     #m0400                   *3101: 8e 04 00       '...'
                lda     #$60                     *3104: 86 60          '.`'
z3106           sta     ,x+                      *3106: a7 80          '..'
                cmpx    #m0601                   *3108: 8c 06 01       '...'
                bne     z3106                    *310b: 26 f9          '&.'
z310d           jsr     z3237                    *310d: bd 32 37       '.27'
z3110           jsr     [za000]                  *3110: ad 9f a0 00    '....'
                cmpa    #$31                     *3114: 81 31          '.1'
                lbeq    z32db                    *3116: 10 27 01 c1    '.'..'
                cmpa    #$32                     *311a: 81 32          '.2'
                lbeq    z32e1                    *311c: 10 27 01 c1    '.'..'
                bne     z3110                    *3120: 26 ee          '&.'
                swi                              *3122: 3f             '?'

                fdb     $00ff,$00ff,$00ff,$00ff,$00ff,$00ff,$00ff,$00ff
                fdb     $00ff,$00ff,$00ff,$00ff,$00ff,$00ff,$00ff,$00ff
                fdb     $00ff,$00ff
                fcb     $00

z3148           ldx     #m4558                   *3148: 8e 45 58       '.EX'
                cmpx    m8000                    *314b: bc 80 00       '...'
                lbne    z31ef                    *314e: 10 26 00 9d    '.&..'
                ldx     #m8183                   *3152: 8e 81 83       '...'
                ldy     #m3530                   *3155: 10 8e 35 30    '..50'
z3159           lda     ,x+                      *3159: a6 80          '..'
                sta     ,y                       *315b: a7 a4          '..'
                nop                              *315d: 12             '.'
                leay    1,y                      *315e: 31 21          '1!'
                cmpx    #m8264                   *3160: 8c 82 64       '..d'
                bne     z3159                    *3163: 26 f4          '&.'
                ldx     #m3530                   *3165: 8e 35 30       '.50'
                stx     m012b                    *3168: bf 01 2b       '..+'
                ldx     #m361b                   *316b: 8e 36 1b       '.6.'
                stx     m0130                    *316e: bf 01 30       '..0'
                lda     #$05                     *3171: 86 05          '..'
                sta     m3530                    *3173: b7 35 30       '.50'
                sta     m3533                    *3176: b7 35 33       '.53'
                sta     m353b                    *3179: b7 35 3b       '.5;'
                sta     m353b                    *317c: b7 35 3b       '.5;'
                jmp     z31ef                    *317f: 7e 31 ef       '~1.'

                fcc     "THIS PROGRAM IS FOR REVIEW ONLY,"
                fcc     "NOT FOR SALE.4-1-83 "
                fcc     "DAVID ROWLAND "
                fcc     "COLOR-PHAZE INC. "
                fcc     "PO BOX 7594 "
                fcc     "G'VILLESC29640"

                ldx     #maa66                   *31ef: 8e aa 66       '..f'
                ldy     #m3666                   *31f2: 10 8e 36 66    '..6f'
z31f6           lda     ,x+                      *31f6: a6 80          '..'
                sta     ,y                       *31f8: a7 a4          '..'
                nop                              *31fa: 12             '.'
                leay    1,y                      *31fb: 31 21          '1!'
                cmpx    #mab88                   *31fd: 8c ab 88       '...'
                bne     z31f6                    *3200: 26 f4          '&.'
                ldx     #m3666                   *3202: 8e 36 66       '.6f'
                stx     m0121                    *3205: bf 01 21       '..!'
                ldx     #m3719                   *3208: 8e 37 19       '.7.'
                stx     m0126                    *320b: bf 01 26       '..&'
                lda     #$05                     *320e: 86 05          '..'
                sta     m36af                    *3210: b7 36 af       '.6.'
                sta     m36bb                    *3213: b7 36 bb       '.6.'
                sta     m36c0                    *3216: b7 36 c0       '.6.'
                sta     m36ce                    *3219: b7 36 ce       '.6.'
                sta     m36ed                    *321c: b7 36 ed       '.6.'
                ldx     #ma11d                   *321f: 8e a1 1d       '...'
                ldy     #m009f                   *3222: 10 8e 00 9f    '....'
z3226           lda     ,x+                      *3226: a6 80          '..'
                nop                              *3228: 12             '.'
                sta     ,y                       *3229: a7 a4          '..'
                nop                              *322b: 12             '.'
                leay    1,y                      *322c: 31 21          '1!'
                cmpx    #ma129                   *322e: 8c a1 29       '..)'
                bne     z3226                    *3231: 26 f3          '&.'
                jmp     za4d0                    *3233: 7e a4 d0       '~..'
                rts                              *3236: 39             '9'
z3237           nop                              *3237: 12             '.'
                lbra    z32ab                    *3238: 16 00 70       '..p'

m323b           fcc     "MENU                         **********            "
                fcb     $40
                fcc     "     1-->RETURN TO BASIC        "
                fcc     "     2-->MAKE PROTECTED COPY"

z32ab           ldx     #m044d                   *32ab: 8e 04 4d       '..M'
                ldy     #m323b                   *32ae: 10 8e 32 3b    '..2;'
z32b2           lda     ,y+                      *32b2: a6 a0          '..'
                cmpa    #$40                     *32b4: 81 40          '.@'
                beq     z32d1                    *32b6: 27 19          ''.'
z32b8           cmpa    #$40                     *32b8: 81 40          '.@'
                bls     z32c8                    *32ba: 23 0c          '#.'
z32bc           sta     ,x                       *32bc: a7 84          '..'
                nop                              *32be: 12             '.'
                leax    1,x                      *32bf: 30 01          '0.'
                cmpy    #m32ab                   *32c1: 10 8c 32 ab    '..2.'
                bne     z32b2                    *32c5: 26 eb          '&.'
                rts                              *32c7: 39             '9'
z32c8           adda    ma15a                    *32c8: bb a1 5a       '..Z'
                adda    ma15f                    *32cb: bb a1 5f       '.._'
                lbra    z32bc                    *32ce: 16 ff eb       '...'
z32d1           leay    1,y                      *32d1: 31 21          '1!'
                lda     #$60                     *32d3: 86 60          '.`'
                leax    $60,x                    *32d5: 30 88 60       '0.`'
                lbra    z32b8                    *32d8: 16 ff dd       '...'
z32db           jsr     za928                    *32db: bd a9 28       '..('
                jmp     za06e                    *32de: 7e a0 6e       '~.n'
z32e1           ldx     #m4e41                   *32e1: 8e 4e 41       '.NA'
                stx     m0544                    *32e4: bf 05 44       '..D'
                ldx     #m4d45                   *32e7: 8e 4d 45       '.ME'
                stx     m0546                    *32ea: bf 05 46       '..F'
                lda     #$8f                     *32ed: 86 8f          '..'
                sta     m0548                    *32ef: b7 05 48       '..H'
                lda     #$af                     *32f2: 86 af          '..'
                sta     m0549                    *32f4: b7 05 49       '..I'
                ldb     #$af                     *32f7: c6 af          '..'
                ldy     #m01d2                   *32f9: 10 8e 01 d2    '....'
                ldx     #m0549                   *32fd: 8e 05 49       '..I'
z3300           jsr     [za000]                  *3300: ad 9f a0 00    '....'
                cmpa    #$08                     *3304: 81 08          '..'
                beq     z32e1                    *3306: 27 d9          ''.'
                cmpa    #$40                     *3308: 81 40          '.@'
                bgt     z3312                    *330a: 2e 06          '..'
                cmpa    #$0d                     *330c: 81 0d          '..'
                beq     z3326                    *330e: 27 16          ''.'
                bra     z3300                    *3310: 20 ee          ' .'
z3312           cmpa    #$5b                     *3312: 81 5b          '.['
                bcs     z3318                    *3314: 25 02          '%.'
                bra     z3300                    *3316: 20 e8          ' .'
z3318           sta     ,y+                      *3318: a7 a0          '..'
                sta     ,x+                      *331a: a7 80          '..'
                stb     ,x                       *331c: e7 84          '..'
                cmpy    #m01da                   *331e: 10 8c 01 da    '....'
                lbcs    z3300                    *3322: 10 25 ff da    '.%..'
z3326           ldx     m0019                    *3326: 9e 19          '..'
                stx     m2d60                    *3328: bf 2d 60       '.-`'
                ldx     m001b                    *332b: 9e 1b          '..'
                stx     m2d62                    *332d: bf 2d 62       '.-b'
                jsr     za7ca                    *3330: bd a7 ca       '...'
                lda     #$02                     *3333: 86 02          '..'
                sta     m01e2                    *3335: b7 01 e2       '...'
                lda     #$00                     *3338: 86 00          '..'
                sta     m01e3                    *333a: b7 01 e3       '...'
                sta     m01e4                    *333d: b7 01 e4       '...'
                lda     #$00                     *3340: 86 00          '..'
                sta     m01e5                    *3342: b7 01 e5       '...'
                lda     #$9f                     *3345: 86 9f          '..'
                sta     m01e6                    *3347: b7 01 e6       '...'
                lda     #$00                     *334a: 86 00          '..'
                sta     m01e7                    *334c: b7 01 e7       '...'
                lda     #$9f                     *334f: 86 9f          '..'
                sta     m01e8                    *3351: b7 01 e8       '...'
                jsr     z33b8                    *3354: bd 33 b8       '.3.'
                jsr     z33b8                    *3357: bd 33 b8       '.3.'
                lda     #$02                     *335a: 86 02          '..'
                ldx     #m0000                   *335c: 8e 00 00       '...'
                jsr     za663                    *335f: bd a6 63       '..c'
                ldx     #m33a9                   *3362: 8e 33 a9       '.3.'
                stx     m0019                    *3365: 9f 19          '..'
                ldx     #m33bd                   *3367: 8e 33 bd       '.3.'
                stx     m001b                    *336a: 9f 1b          '..'
                nop                              *336c: 12             '.'
                lda     #$16                     *336d: 86 16          '..'
                sta     m007d                    *336f: 97 7d          '.}'
                lda     #$01                     *3371: 86 01          '..'
                sta     m007c                    *3373: 97 7c          '.|'
                ldx     #m33a9                   *3375: 8e 33 a9       '.3.'
                stx     m007e                    *3378: 9f 7e          '.~'
                jsr     za471                    *337a: bd a4 71       '..q'
                ldx     #z3148                   *337d: 8e 31 48       '.1H'
                stx     m0019                    *3380: 9f 19          '..'
                ldx     #m3239                   *3382: 8e 32 39       '.29'
                stx     m001b                    *3385: 9f 1b          '..'
                jsr     za471                    *3387: bd a4 71       '..q'
                ldx     m2d60                    *338a: be 2d 60       '.-`'
                stx     m0019                    *338d: 9f 19          '..'
                ldx     m2d62                    *338f: be 2d 62       '.-b'
                stx     m001b                    *3392: 9f 1b          '..'
                jsr     za471                    *3394: bd a4 71       '..q'
                jsr     za7e9                    *3397: bd a7 e9       '...'
                ldx     #m0400                   *339a: 8e 04 00       '...'
                lda     #$8f                     *339d: 86 8f          '..'
z339f           sta     ,x+                      *339f: a7 80          '..'
                cmpx    #m0600                   *33a1: 8c 06 00       '...'
                bcs     z339f                    *33a4: 25 f9          '%.'
                jmp     z310d                    *33a6: 7e 31 0d       '~1.'
m33a9           nop                              *33a9: 12             '.'
                nop                              *33aa: 12             '.'
                ldx     #z3148                   *33ab: 8e 31 48       '.1H'
                bra     z33b2                    *33ae: 20 02          ' .'
                fdb     $adae                    *33b0: ad ae          '..'
z33b2           jsr     za529                    *33b2: bd a5 29       '..)'
                jmp     z3148                    *33b5: 7e 31 48       '~1H'
z33b8           ldx     #m0003                   *33b8: 8e 00 03       '...'
z33bb           ldy     #mfde8                   *33bb: 10 8e fd e8    '....'
z33bf           leay    -1,y                     *33bf: 31 3f          '1?'
                bne     z33bf                    *33c1: 26 fc          '&.'
                leax    -1,x                     *33c3: 30 1f          '0.'
                bne     z33bb                    *33c5: 26 f4          '&.'
                rts                              *33c7: 39             '9'
                nop                              *33c8: 12             '.'     

                End     Start